package com.zhongzheng.modules.order.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.order.bo.OrderBusinessAddBo;
import com.zhongzheng.modules.order.bo.OrderBusinessEditBo;
import com.zhongzheng.modules.order.bo.OrderBusinessQueryBo;
import com.zhongzheng.modules.order.domain.OrderBusiness;
import com.zhongzheng.modules.order.mapper.OrderBusinessMapper;
import com.zhongzheng.modules.order.service.IOrderBusinessService;
import com.zhongzheng.modules.order.vo.OrderBusinessVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 订单业务信息Service业务层处理
 *
 * @author hjl
 * @date 2021-11-08
 */
@Service
public class OrderBusinessServiceImpl extends ServiceImpl<OrderBusinessMapper, OrderBusiness> implements IOrderBusinessService {

    @Override
    public OrderBusinessVo queryById(String orderSn){
        OrderBusiness db = this.baseMapper.selectById(orderSn);
        return BeanUtil.toBean(db, OrderBusinessVo.class);
    }

    @Override
    public List<OrderBusinessVo> queryList(OrderBusinessQueryBo bo) {
        LambdaQueryWrapper<OrderBusiness> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getBusinessOwner()), OrderBusiness::getBusinessOwner, bo.getBusinessOwner());
        lqw.eq(StrUtil.isNotBlank(bo.getDept()), OrderBusiness::getDept, bo.getDept());
        lqw.eq(StrUtil.isNotBlank(bo.getSource()), OrderBusiness::getSource, bo.getSource());
        lqw.eq(StrUtil.isNotBlank(bo.getSchool()), OrderBusiness::getSchool, bo.getSchool());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<OrderBusinessVo> entity2Vo(Collection<OrderBusiness> collection) {
        List<OrderBusinessVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, OrderBusinessVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<OrderBusiness> page = (Page<OrderBusiness>)collection;
            Page<OrderBusinessVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(OrderBusinessAddBo bo) {
        OrderBusiness add = BeanUtil.toBean(bo, OrderBusiness.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(OrderBusinessEditBo bo) {
        OrderBusiness update = BeanUtil.toBean(bo, OrderBusiness.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(OrderBusiness entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
